<template>
  <v-container>
    <v-data-table
      :headers="zoneHeaders"
      :items="zones"
      :single-expand="true"
      item-key="id"
      show-expand
      disable-filtering
      disable-pagination
      hide-default-footer
      hide-default-header
    >
      <template #expanded-item="{ headers, item }">
        <td :colspan="headers.length">
          <items-per-zone
            :all-stored="allStored(item)"
            :zone-id="item.id"
            :order-ids="orderIdsByZone(item.id)"
            :items="itemProductsInZone(item.id)"
          />
        </td>
      </template>

      <template #item.zoneId="{ item }">
        Zona {{ hashId({ id: item.id }) }}
      </template>

      <template #item.status="{ item }">
        <v-chip
          class="ma-2 white--text"
          :color="allStored(item) ? 'primary' : 'blue darken-2'"
        >
          <v-icon color="white" left>
            {{ allStored(item) ? 'mdi-check-circle-outline' : 'mdi-clock' }}
          </v-icon>
          {{ allStored(item) ? 'Ítems almacenados' : 'Ítems pendientes' }}
        </v-chip>
      </template>
    </v-data-table>
  </v-container>
</template>

<script>
import { mapState } from 'vuex';
import { all, equals, filter, groupBy, includes, pluck, prop, propEq } from 'ramda';
import ItemsPerZone from '~/components/Storage/Shipments/Details/Extra/AssignedZones/ItemsPerZone';
import { hashId } from '~/helpers/format/ids';

export default {
  name: 'AssignedZones',
  components: {
    ItemsPerZone,
  },
  data() {
    return {
      zoneHeaders: [
        { align: 'start', value: 'zoneId' },
        { align: 'center', value: 'status' },
      ],
    };
  },
  computed: {
    ...mapState({
      orders: state => state.storage.shipments.current.orders,
      zones: state => state.storage.shipments.current.zones,
      items: state => state.storage.shipments.current.items,
    }),
  },
  methods: {
    hashId,
    ordersByZone(zoneId) {
      return filter(propEq('zoneAssignedId', zoneId), this.orders);
    },
    orderIdsByZone(zoneId) {
      return pluck('orderId', this.ordersByZone(zoneId));
    },
    itemProductsInZone(zoneId) {
      const orderIds = this.orderIdsByZone(zoneId);
      const itemsForOrders = filter(item => includes(prop('orderId', item), orderIds), this.items);
      return groupBy(prop('productDetailId'), itemsForOrders);
    },
    allStored({ id }) {
      const status = pluck('areStored', this.ordersByZone(id));
      return all(equals(true), status);
    },
  },
};
</script>
